<?php
/*
Plugin Name:	Flip Product Images
Plugin URI:		https://profiles.wordpress.org/sumitsingh/
Description:	Image Flipping & Floating Cart Buttons on Product Archives in Oxygen.
Version:		1.0.0
Author:			WP Lovers
Author URI:		https://www.facebook.com/wploversteam
License:		GPL-2.0+
License URI:	http://www.gnu.org/licenses/gpl-2.0.txt

This plugin is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 2 of the License, or
any later version.

This plugin is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with This plugin. If not, see {URI to Plugin License}.
*/

if ( ! defined( 'WPINC' ) ) {
	die;
}

add_action( 'wp_head', 'product_img_flipped_style' );
function product_img_flipped_style(){
	 // check if WooCommerce active
	if (!class_exists( 'WooCommerce' ) ) {
	  return;
	}

  	/* Abort if we're not on shop or product archive page */
	if ( !is_shop() && !is_product_category() && !is_product_tag() ) {
		return;
	}
?>
<style>
/* Image swap on hover */
img.secondary-image,
.woocommerce .oxy-woo-products ul.products li.product a img.secondary-image {
    position: absolute;
    opacity: 0;
  	-webkit-transition: opacity .4s ease;
  	-o-transition: opacity .4s ease;
  	transition: opacity .4s ease;
  	pointer-events: none;
}

.woocommerce .oxy-woo-products ul.products li.product a {
    position: relative;
}

.woocommerce .oxy-woo-products ul.products li.product:hover a.woocommerce-loop-product__link .secondary-image,
.woocommerce .oxy-woo-products ul.products li.product .button:hover + a.woocommerce-loop-product__link .secondary-image {
    opacity: 1;
}

.woocommerce .oxy-woo-products ul.products li.product {
	display: -webkit-box;
	display: -ms-flexbox;
	display: flex;
    -webkit-box-orient: vertical;
    -webkit-box-direction: normal;
        -ms-flex-direction: column;
            flex-direction: column;
    -webkit-box-pack: end;
        -ms-flex-pack: end;
            justify-content: flex-end;
}

.woocommerce .oxy-woo-products .woocommerce-loop-product__link {
  -webkit-box-ordinal-group: 0;
      -ms-flex-order: -1;
          order: -1;
}

@media (min-width: 992px) {
  
  /* Button appear on hover */
  .woocommerce .oxy-woo-products ul.products li.product, 
  .woocommerce-page  .oxy-woo-products ul.products li.product {
      position: relative;
  }

  .woocommerce .oxy-woo-products ul.products li.product .button,
  .woocommerce .oxy-woo-products ul.products li.product .added_to_cart {
      position: absolute;
      top: 50%;
      left: 50%;
      width: 60%;
      opacity: 0;
      visibility: hidden;
      -webkit-transition: all .4s ease;
      -o-transition: all .4s ease;
      transition: all .4s ease;
      z-index: 1;
  }
  
  .woocommerce .oxy-woo-products ul.products li.product .button {
    -webkit-transform: translate(-50%, 10%);
        -ms-transform: translate(-50%, 10%);
            transform: translate(-50%, 10%);
  }
  
  .woocommerce .oxy-woo-products ul.products li.product .added_to_cart {
    -webkit-transform: translate(-50%, 100%);
        -ms-transform: translate(-50%, 100%);
            transform: translate(-50%, 100%);
  }

  .woocommerce .oxy-woo-products ul.products li.product:hover .button {
      opacity: 1;
      visibility: visible;
      -webkit-transform: translate(-50%, 0);
          -ms-transform: translate(-50%, 0);
              transform: translate(-50%, 0);
  }
  
   .woocommerce .oxy-woo-products ul.products li.product:hover .added_to_cart {
     opacity: 1;
      visibility: visible;
     -webkit-transform: translate(-50%, 90%);
         -ms-transform: translate(-50%, 90%);
             transform: translate(-50%, 90%);
  }
  
}

/* Image swap on hover */
img.secondary-image,
.woocommerce .oxy-woo-element ul.products li.product a img.secondary-image {
    position: absolute;
    opacity: 0;
  	-webkit-transition: opacity .4s ease;
  	-o-transition: opacity .4s ease;
  	transition: opacity .4s ease;
  	pointer-events: none;
}

.woocommerce .oxy-woo-element ul.products li.product a {
    position: relative;
}

.woocommerce .oxy-woo-element ul.products li.product:hover a.woocommerce-loop-product__link .secondary-image,
.woocommerce .oxy-woo-element ul.products li.product .button:hover + a.woocommerce-loop-product__link .secondary-image {
    opacity: 1;
}

.woocommerce .oxy-woo-element ul.products li.product {
	display: -webkit-box;
	display: -ms-flexbox;
	display: flex;
    -webkit-box-orient: vertical;
    -webkit-box-direction: normal;
        -ms-flex-direction: column;
            flex-direction: column;
    -webkit-box-pack: end;
        -ms-flex-pack: end;
            justify-content: flex-end;
}

.woocommerce .oxy-woo-element .woocommerce-loop-product__link {
  -webkit-box-ordinal-group: 0;
      -ms-flex-order: -1;
          order: -1;
}

@media (min-width: 992px) {
  
  /* Button appear on hover */
  .woocommerce .oxy-woo-element ul.products li.product, 
  .woocommerce-page  .oxy-woo-element ul.products li.product {
      position: relative;
  }

  .woocommerce .oxy-woo-element ul.products li.product .button,
  .woocommerce .oxy-woo-element ul.products li.product .added_to_cart {
      position: absolute;
      top: 50%;
      left: 50%;
      width: 60%;
      opacity: 0;
      visibility: hidden;
      -webkit-transition: all .4s ease;
      -o-transition: all .4s ease;
      transition: all .4s ease;
      z-index: 1;
  }
  
  .woocommerce .oxy-woo-element ul.products li.product .button {
    -webkit-transform: translate(-50%, 10%);
        -ms-transform: translate(-50%, 10%);
            transform: translate(-50%, 10%);
  }
  
  .woocommerce .oxy-woo-element ul.products li.product .added_to_cart {
    -webkit-transform: translate(-50%, 100%);
        -ms-transform: translate(-50%, 100%);
            transform: translate(-50%, 100%);
  }

  .woocommerce .oxy-woo-element ul.products li.product:hover .button {
      opacity: 1;
      visibility: visible;
      -webkit-transform: translate(-50%, 0);
          -ms-transform: translate(-50%, 0);
              transform: translate(-50%, 0);
  }
  
   .woocommerce .oxy-woo-element ul.products li.product:hover .added_to_cart {
     opacity: 1;
      visibility: visible;
     -webkit-transform: translate(-50%, 90%);
         -ms-transform: translate(-50%, 90%);
             transform: translate(-50%, 90%);
  }
  
}
</style>
<?php
}

add_action( 'wp_head', 'product_woo_image_flipping' );
function product_woo_image_flipping() {

    // check if WooCommerce active
	if (!class_exists( 'WooCommerce' ) ) {
	  return;
	}

  	/* Abort if we're not on shop or product archive page */
	if ( !is_shop() && !is_product_category() && !is_product_tag() ) {
		return;
	}

  	/* Add Second Thumbnail below first thumbnail */
	add_action( 'woocommerce_before_shop_loop_item_title', 'woocommerce_template_loop_second_product_thumbnail' );

	/* Reposition button */
	remove_action( 'woocommerce_after_shop_loop_item', 'woocommerce_template_loop_add_to_cart' );
	add_action( 'woocommerce_before_shop_loop_item', 'woocommerce_template_loop_add_to_cart', 2 );
}

//* Function to get second product thumbnail from product gallery
function woocommerce_template_loop_second_product_thumbnail() {
  
  global $product;

  $attachment_ids = $product->get_gallery_image_ids();

  if ( $attachment_ids ) {
	$attachment_ids     = array_values( $attachment_ids );
	$secondary_image_id = $attachment_ids['0'];

	$secondary_image_alt = get_post_meta( $secondary_image_id, '_wp_attachment_image_alt', true );
	$secondary_image_title = get_the_title($secondary_image_id);

	echo wp_get_attachment_image(
	  $secondary_image_id,
	  'shop_catalog',
	  '',
	  array(
		'class' => 'secondary-image attachment-woocommerce_thumbnail',
		'alt' => $secondary_image_alt,
		'title' => $secondary_image_title
	  )
	);
  }
}